﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals

	Private mID As String
	Private mWS As WebSocket
	
End Sub

Public Sub Initialize(WS As WebSocket, ID As String)

	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String	

	Script = "$('#'+arguments[0]).remove();" & _
					 "var resizeSelector = $('<div />');" & _
					 "var accordionSelector = $('<div />');" & _
					 "resizeSelector.append(accordionSelector);" & _
					 "resizeSelector.attr('id', arguments[0]);" & _
					 "$('body').append(resizeSelector);" & _
					 "resizeSelector.resizable({resize: function() {accordionSelector.accordion('refresh')}});" & _
					 "accordionSelector.accordion({heightStyle: 'fill'});" & _
					 "resizeSelector.resizable('destroy');"

	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub GetID() As String
	Return mID
End Sub

' ###

Sub AddEvent(EventName As String, PreventDefault As Boolean)
	EventName = EventName.ToLowerCase
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, mID & "_" & EventName, PreventDefault))
End Sub

Sub RemoveEvent(EventName As String)
	EventName = EventName.ToLowerCase
	mWS.Eval("$(arguments[0]).off('" & EventName & "', $(arguments[1]))", Array As Object("#" & mID))
End Sub

Sub SetEventObjectName(EventObjectName As String, EventName As String, PreventDefault As Boolean)
	EventObjectName = EventObjectName.ToLowerCase
	EventName = EventName.ToLowerCase
	RemoveEvent(EventName)
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, EventObjectName & "_" & EventName, PreventDefault))
End Sub

' ###

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub

Sub AppendElementToSection(ElementID As String, Section As Int)

	Dim Script As String

	Script = "var selector = $(arguments[0]).find('div.ui-accordion-content').eq(arguments[1]);" & _
					 "if (selector.length == 1) selector.append($(arguments[2]))"

	mWS.Eval(Script, Array As Object("#" & mID, Section, "#" & ElementID.ToLowerCase))

End Sub

Sub ClearSection(Position As Int)

	Dim Script As String

	Script = "var selector = $(arguments[0]).find('div.ui-accordion-content').eq(arguments[1]);" & _
					 "if (selector.length == 1) selector.empty()"

	mWS.Eval(Script, Array As Object("#" & mID, Position))

End Sub

Sub Remove()
	mWS.Eval("$(arguments[0]).remove()", Array As Object("#" & mID))
End Sub

Sub AddSection(Text As String, Position As Int)

	Dim Script As String

	Script = "var selector = $(arguments[0]).find('.ui-accordion');" & _
					 "var headerItem = $('<h3 />');" & _
					 "headerItem.html('<span class=''ui-accordion-header-text''></span>');" & _
					 "var divItem = $('<div />');" & _
					 "if (arguments[1] <= -1 || arguments[1] >= selector.find('h3').length) {" & _
					 " selector.append(headerItem);" & _
					 "} else {" & _
					 " headerItem.insertBefore(selector.find('h3').eq(arguments[1]));" & _
					 "}" & _
					 "divItem.insertAfter(headerItem);" & _
					 "selector.accordion('refresh');" & _
					 "divItem.css('position', 'relative');"
				
	Script = Script.Replace("''", Chr(34))
				
	mWS.Eval(Script, Array As Object("#" & mID, Position))

	SetSectionText(Position, Text)

End Sub

Sub RemoveSection(Position As Int)

	Dim Script As String

	Script = "$(arguments[0]).find('h3.ui-accordion-header').eq(arguments[1]).remove();" & _
					 "$(arguments[0]).find('div.ui-accordion-content').eq(arguments[1]).remove();"

	mWS.Eval(Script, Array As Object("#" & mID, Position))
	
End Sub

Sub GetSectionText(Position As Int) As Future
	Dim Script As String
	Script = "return $(arguments[0]).find('h3.ui-accordion-header').eq(arguments[1]).find('span.ui-accordion-header-text').html()"
	Return mWS.EvalWithResult(Script,	Array As Object("#" & mID, Position))
End Sub
Sub SetSectionText(Position As Int, Text As String)
	Dim Script As String
	Script = "$(arguments[0]).find('h3.ui-accordion-header').eq(arguments[1]).find('span.ui-accordion-header-text').html(arguments[2])"
	mWS.Eval(Script, Array As Object("#" & mID, Position, Text))
End Sub	

Sub GetVisible() As Future
	Return mWS.EvalWithResult("return ($(arguments[0]).css('display')!='none')", Array As Object("#" & mID))
End Sub
Sub SetVisible(Visible As Boolean)
	If Visible = True Then
		SetCss("display", "")
	Else
		SetCss("display", "none")
	End If
End Sub

' ######################

Sub Resize(Left As String, Top As String, Width As String, Height As String)

	Dim CSS As String

	CSS = "$(arguments[0]).css({"
	
	If Left   <> -1 Then CSS = CSS & "'left':'" & Left & "px',"
	If Top    <> -1 Then CSS = CSS & "'top':'" & Top & "px',"
	If Width  <> -1 Then CSS = CSS & "'width':'" & Width & "px',"
	If Height <> -1 Then CSS = CSS & "'height':'" & Height & "px',"
	
	If CSS.EndsWith(",") Then	
	
		CSS = CSS.SubString2(0, CSS.Length - 1)
	
		CSS = CSS & "});"
	
		mWS.Eval(CSS, Array As Object("#" & mID))
		
	End If
	
End Sub

Sub GetTop() As Future
	Return GetCss("top")
End Sub
Sub SetTop(Top As String)
	SetCss("top", Top & "px")
End Sub

Sub GetLeft As Future
	Return GetCss("left")
End Sub
Sub SetLeft(Left As String)
	SetCss("left", Left & "px")
End Sub

Sub GetWidth As Future
	Return GetCss("width")
End Sub
Sub SetWidth(Width As String)
	SetCss("width", Width)
End Sub

Sub GetHeight As Future
	Return GetCss("height")
End Sub
Sub SetHeight(Height As String)
	SetCss("height", Height)
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub

