﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals

	Private mID As String
	Private mWS As WebSocket

End Sub

Public Sub Initialize(WS As WebSocket, ID As String)

	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String	

	Script = "$('#'+arguments[0]).remove();" & _
					 "var selector = $('<div />');" & _
					 "selector.attr('id', arguments[0]);" & _
					 "selector.css('position', 'absolute');" & _
					 "selector.css('border', '1px solid black');" & _
					 "$('body').append(selector);" & _
					 "var editor = ace.edit(arguments[0]);" 

	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub GetID() As String
	Return mID
End Sub

' ###

Sub AddEvent(EventName As String, PreventDefault As Boolean)
	EventName = EventName.ToLowerCase
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, mID & "_" & EventName, PreventDefault))
End Sub

Sub RemoveEvent(EventName As String)
	EventName = EventName.ToLowerCase
	mWS.Eval("$(arguments[0]).off('" & EventName & "', $(arguments[1]))", Array As Object("#" & mID))
End Sub

Sub SetEventObjectName(EventObjectName As String, EventName As String, PreventDefault As Boolean)
	EventObjectName = EventObjectName.ToLowerCase
	EventName = EventName.ToLowerCase
	RemoveEvent(EventName)
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, EventObjectName & "_" & EventName, PreventDefault))
End Sub

' ###

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub

Sub Remove()
	mWS.Eval("$(arguments[0]).remove()", Array As Object("#" & mID))
End Sub

Sub GetValue() As Future

	Dim Script As String	

	Script = "var editor = ace.edit(arguments[0]);" & _
					 "return editor.getSession().getValue();"

	Return mWS.EvalWithResult(Script, Array As Object(mID))
	
End Sub
Sub SetValue(Value As String)
	
	Dim Script As String	

	Script = "var editor = ace.edit(arguments[0]);" & _
					 "editor.getSession().setValue(arguments[1]);"

	mWS.Eval(Script, Array As Object(mID, Value))	
	
End Sub

Sub GetTheme As Future
	
	Dim Script As String	

	Script = "var editor = ace.edit(arguments[0]);" & _
					 "return editor.getTheme();"

	Return mWS.EvalWithResult(Script, Array As Object(mID))

End Sub
Sub SetTheme(Theme As String)

	Dim Script As String	

	Script = "var editor = ace.edit(arguments[0]);" & _
					 "editor.setTheme('ace/theme/" & Theme & "');"

	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub GetMode() As Future
	
	Dim Script As String	

	Script = "var editor = ace.edit(arguments[0]);" & _
					 "return editor.getMode();"

	Return mWS.EvalWithResult(Script, Array As Object(mID))

End Sub
Sub SetMode(Mode As String)

	Dim Script As String	

	Script = "var editor = ace.edit(arguments[0]);" & _
					 "editor.getSession().setMode('ace/mode/" & Mode & "');"

	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub SetFocus()

	Dim Script As String	

	Script = "var editor = ace.edit(arguments[0]);" & _
					 "editor.focus()"

	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub GetVisible() As Future
	Return mWS.EvalWithResult("return ($(arguments[0]).css('display')!='none')", Array As Object("#" & mID))
End Sub
Sub SetVisible(Visible As Boolean)
	If Visible = True Then
		SetCss("display", "")
	Else
		SetCss("display", "none")
	End If
End Sub

' ######################

Sub GetTop() As Future
	Return GetCss("top")
End Sub
Sub SetTop(Top As String)
	SetCss("top", Top & "px")
End Sub

Sub GetLeft As Future
	Return GetCss("left")
End Sub
Sub SetLeft(Left As String)
	SetCss("left", Left & "px")
End Sub

Sub GetWidth As Future
	Return GetCss("width")
End Sub
Sub SetWidth(Width As String)
	SetCss("width", Width)
End Sub

Sub GetHeight As Future
	Return GetCss("height")
End Sub
Sub SetHeight(Height As String)
	SetCss("height", Height)
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub

