﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals

	Private mID As String
	Private mWS As WebSocket

	Private mClosable As Boolean = True
	Private mMaximizable As Boolean = False
	Private mCollapsable As Boolean = False
	Private mMinimizable As Boolean = False

End Sub

Public Sub Initialize(WS As WebSocket, ID As String, Modal As Boolean)

	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String
	
	Script = "$('#'+arguments[0]).dialog('destroy').remove();" & _
					 "var selector = $('<div />');" & _
					 "selector.attr('id', arguments[0]);" & _
					 "$('body').append(selector);" & _
					 "selector.dialog({ " & _
					 " autoOpen: false, " & _
					 " modal: arguments[1]" & _
					 "})" 

	mWS.Eval(Script, Array As Object(mID, Modal))
	
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogbeforeclose", mID & "_beforeclose", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogclose", mID & "_close", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogcreate", mID & "_create", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogdrag", mID & "_drag", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogdragstart", mID & "_dragstart", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogdragstop", mID & "_dragstop", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogfocus", mID & "_focus", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogopen", mID & "_open", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogresize", mID & "_resize", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogresizestart", mID & "_resizestart", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "dialogresizestop", mID & "_resizestop", False))

End Sub

Public Sub GetID() As String
	Return mID
End Sub

' ###

Sub AddEvent(EventName As String, PreventDefault As Boolean)
	EventName = EventName.ToLowerCase
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, mID & "_" & EventName, PreventDefault))
End Sub

Sub RemoveEvent(EventName As String)
	EventName = EventName.ToLowerCase
	mWS.Eval("$(arguments[0]).off('" & EventName & "', $(arguments[1]))", Array As Object("#" & mID))
End Sub

Sub SetEventObjectName(EventObjectName As String, EventName As String, PreventDefault As Boolean)
	EventObjectName = EventObjectName.ToLowerCase
	EventName = EventName.ToLowerCase
	RemoveEvent(EventName)
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, EventObjectName & "_" & EventName, PreventDefault))
End Sub

' ###

Public Sub Open()

	Dim Script As String = "$(arguments[0]).dialog('open').dialogExtend({" & _
												 "	'closable': arguments[1], " & _
												 "  'collapsable': arguments[2], " & _
												 "	'maximizable': arguments[3], " & _
												 "	'minimizable': arguments[4] " & _
												 "});"

	' mWS.Eval("$(arguments[0]).dialog('open')", Array As Object("#" & mID))
	
	mWS.Eval(Script, Array As Object("#" & mID, mClosable, mCollapsable, mMaximizable, mMinimizable))
	
End Sub

Public Sub Close()
	mWS.Eval("$(arguments[0]).dialog('close')", Array As Object("#" & mID))
End Sub

Public Sub Remove()
	mWS.Eval("$(arguments[0]).dialog('destroy').remove()", Array As Object("#" & mID))
End Sub

Public Sub MoveToTop()
	mWS.Eval("$(arguments[0]).dialog('moveToTop')", Array As Object("#" & mID))
End Sub

Public Sub SetClosable(Closable As Boolean)
	mClosable = Closable
End Sub
Public Sub SetMaximizable(Maximizable As Boolean)
	mMaximizable = Maximizable
End Sub
Public Sub SetMinimizable(Minimizable As Boolean)
	mMinimizable = Minimizable
End Sub
Public Sub SetCollapsable(Collapsable As Boolean)
	mCollapsable = Collapsable
End Sub

' ######################

Sub Resize(Left As String, Top As String, Width As String, Height As String)

	If Left   <> -1 Then SetLeft(Left)
	If Top    <> -1 Then SetTop(Top)
	If Width  <> -1 Then SetWidth(Width)
	If Height <> -1 Then SetHeight(Height)
	
End Sub

Sub GetTop() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).dialog('option', 'position')[1]", Array As Object("#" & mID))
End Sub
Sub SetTop(Top As Int)
   
	Dim Script As String

	Script = _
	"var pos = $(arguments[0]).dialog('option', 'position');" & _
	"var x = pos[0];" & _
	"var y = arguments[1];" & _
	"$(arguments[0]).dialog('option', 'position', [x, y]);"
	 
	mWS.Eval(Script, Array As Object("#" & mID, Top))
	 
End Sub

Sub GetLeft() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).dialog('option', 'position')[0]", Array As Object("#" & mID))
End Sub
Sub SetLeft(Left As Int)

	Dim Script As String

	Script = _
	"var pos = $(arguments[0]).dialog('option', 'position');" & _
	"var x = arguments[1];" & _
	"var y = pos[1];" & _
	"$(arguments[0]).dialog('option', 'position', [x, y]);"
	 
	mWS.Eval(Script, Array As Object("#" & mID, Left))
	
End Sub

Sub GetResizable() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).dialog('option', 'resizable')", Array As Object("#" & mID))
End Sub
Sub SetResizable(Resizable As Boolean)
	mWS.Eval("$(arguments[0]).dialog('option', 'resizable', arguments[1])", Array As Object("#" & mID, Resizable))
End Sub

Sub GetTitle() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).dialog('option', 'title')", Array As Object("#" & mID))
End Sub
Sub SetTitle(Title As String)
	mWS.Eval("$(arguments[0]).dialog('option', 'title', arguments[1])", Array As Object("#" & mID, Title))
End Sub

Sub GetDraggable() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).dialog('option', 'draggable')", Array As Object("#" & mID))
End Sub
Sub SetDraggable(Draggable As Boolean)
	mWS.Eval("$(arguments[0]).dialog('option', 'draggable', arguments[1])", Array As Object("#" & mID, Draggable))
End Sub

Sub GetWidth() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).dialog('option', 'width')", Array As Object("#" & mID))
End Sub
Sub SetWidth(Width As Int)
	mWS.Eval("$(arguments[0]).dialog('option', 'width', arguments[1])", Array As Object("#" & mID, Width))
End Sub

Sub GetHeight() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).dialog('option', 'height')", Array As Object("#" & mID))
End Sub
Sub SetHeight(Height As Int)
	mWS.Eval("$(arguments[0]).dialog('option', 'height', arguments[1])", Array As Object("#" & mID, Height))
End Sub

Sub Hide()
	mWS.Eval("$(arguments[0]).dialog('option', 'hide')", Array As Object("#" & mID))
End Sub
Sub Show()
	mWS.Eval("$(arguments[0]).dialog('option', 'show')", Array As Object("#" & mID))
End Sub
