﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mID As String
	Private mWS As WebSocket
	
End Sub

Public Sub Initialize(WS As WebSocket, ID As String)
	
	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String
	
	Script = "$('#'+arguments[0]).remove();" & _
					 "var selector = $('<select />');" & _
					 "selector.attr('id', arguments[0]);" & _
					 "selector.attr('size', '999999');" & _
					 "selector.css('position', 'absolute');" & _
					 "selector.addClass('ui-widget');" & _
					 "$('body').append(selector);" 
	
	mWS.Eval(Script, Array As Object(mID))
	
	AddEvent("change", False)
	AddEvent("click", False)
	
End Sub

Sub GetID() As String
	Return mID
End Sub

' ###

Sub AddEvent(EventName As String, PreventDefault As Boolean)
	EventName = EventName.ToLowerCase
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, mID & "_" & EventName, PreventDefault))
End Sub

Sub RemoveEvent(EventName As String)
	EventName = EventName.ToLowerCase
	mWS.Eval("$(arguments[0]).off('" & EventName & "', $(arguments[1]))", Array As Object("#" & mID))
End Sub

Sub SetEventObjectName(EventObjectName As String, EventName As String, PreventDefault As Boolean)
	EventObjectName = EventObjectName.ToLowerCase
	EventName = EventName.ToLowerCase
	RemoveEvent(EventName)
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, EventObjectName & "_" & EventName, PreventDefault))
End Sub

' ###

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub

Sub Remove()
	mWS.Eval("$(arguments[0]).remove()", Array As Object("#" & mID))
End Sub

Sub GetText() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).val()", Array As Object("#" & mID))
End Sub
Sub SetText(Text As String)
	mWS.Eval("$(arguments[0]).val(arguments[1])", Array As Object("#" & mID, Text))
End Sub

Sub GetDisabled() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).prop(arguments[1])", Array As Object("#" & mID, "disabled"))
End Sub
Sub SetDisabled(Disabled As Boolean)
	mWS.Eval("$(arguments[0]).prop(arguments[1],arguments[2])", Array As Object("#" & mID, "disabled", Disabled))
End Sub

Sub Enable()
	SetDisabled(False)
End Sub
Sub Disable()
	SetDisabled(True)
End Sub

Sub GetTooltip() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, "title"))
End Sub
Sub SetTooltip(Tooltip As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1],arguments[2])", Array As Object("#" & mID, "title", Tooltip))
End Sub

Sub AddItem(ItemText As String, Position As Int, Selected As Boolean)

	Dim Script As StringBuilder
	
	Script.Initialize
	
	' http://jsfiddle.net/NG4QL/
	
	Script.Append("var p = arguments[1];")
	Script.Append("var listsize = $(arguments[0] + ' option').size();")

	Script.Append("if (p == -1) p = listsize;")
	Script.Append("if (p < 0) p = 0;")
	Script.Append("if (p > listsize) p = listsize;")

	If Selected = True Then
		Script.Append("$(arguments[0] + ' option').removeAttr('selected');")
	End If

	Script.Append("if  (p == listsize) {")
	Script.Append(" $(arguments[0]).append($('<option>' + arguments[2] + '</option>'));")
	Script.Append("} else {")
	Script.Append(" $('<option>' + arguments[2] + '</option>').insertBefore($(arguments[0] + ' option').eq(p));")
	Script.Append("}")

	If Selected = True Then
		Script.Append("$(arguments[0] + ' option').eq(p).attr('selected', 'selected');")
	End If

	mWS.Eval(Script.ToString, Array As Object("#" & mID, Position, ItemText))
	
End Sub

Sub RemoveItem(Position As Int)
End Sub

Sub ClearItems()
	mWS.Eval("$(arguments[0]).empty();", Array As Object("#" & mID))
End Sub

Sub SetSelectedIndex(SelectedIndex As Int)

	Dim Script As StringBuilder
	
	Script.Initialize
	
	Script.Append("var p = arguments[1];")
	Script.Append("var listsize = $(arguments[0] + ' option').size();")
	Script.Append("if (p == -1) p = listsize;")
	Script.Append("if (p < 0) p = 0;")
	Script.Append("if (p > listsize) p = listsize;")
	Script.Append("$(arguments[0] + ' option').removeAttr('selected');")
	Script.Append("$(arguments[0] + ' option').eq(p).attr('selected', 'selected');")

	mWS.Eval(Script.ToString, Array As Object("#" & mID, SelectedIndex))

End Sub

Sub GetSelectedIndex() As Future

	Dim Script As StringBuilder
	
	Script.Initialize
	
	Script.Append("var selectedIndex = $(arguments[0] + ' option').index($(arguments[0] + ' option').filter(':selected'));")
	Script.Append("if (typeof (selectedIndex) == 'undefined') selectedIndex = -1;")
	Script.Append("return selectedIndex;")

	Return mWS.EvalWithResult(Script.ToString, Array As Object("#" & mID))

End Sub

Sub GetVisible() As Future
	Return mWS.EvalWithResult("return ($(arguments[0]).css('display')!='none')", Array As Object("#" & mID))
End Sub
Sub SetVisible(Visible As Boolean)
	If Visible = True Then
		SetCss("display", "")
	Else
		SetCss("display", "none")
	End If
End Sub

' ######################

Sub Resize(Left As String, Top As String, Width As String, Height As String)

	Dim CSS As String

	CSS = "$(arguments[0]).css({"
	
	If Left   <> -1 Then CSS = CSS & "'left':'" & Left & "px',"
	If Top    <> -1 Then CSS = CSS & "'top':'" & Top & "px',"
	If Width  <> -1 Then CSS = CSS & "'width':'" & Width & "px',"
	If Height <> -1 Then CSS = CSS & "'height':'" & Height & "px',"
	
	If CSS.EndsWith(",") Then	
	
		CSS = CSS.SubString2(0, CSS.Length - 1)
	
		CSS = CSS & "});"
	
		mWS.Eval(CSS, Array As Object("#" & mID))
		
	End If
	
End Sub

Sub GetTop() As Future
	Return GetCss("top")
End Sub
Sub SetTop(Top As String)
	SetCss("top", Top & "px")
End Sub

Sub GetLeft As Future
	Return GetCss("left")
End Sub
Sub SetLeft(Left As String)
	SetCss("left", Left & "px")
End Sub

Sub GetWidth As Future
	Return GetCss("width")
End Sub
Sub SetWidth(Width As String)
	SetCss("width", Width & "px")
End Sub

Sub GetHeight As Future
	Return GetCss("height")
End Sub
Sub SetHeight(Height As String)
	SetCss("height", Height & "px")
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub