﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mID As String
	Private mWS As WebSocket
	
End Sub

Public Sub Initialize(WS As WebSocket, ID As String)
	
	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String = "$('#'+arguments[0]).remove();" & _
												 "var selector=$('<div />');" & _
												 "selector.attr('id',arguments[0]);" & _
												 "selector.css('position','absolute');" & _
												 "$('body').append(selector.slider());" 
	
	mWS.Eval(Script, Array As Object(mID))
	
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "slidechange", mID & "_change", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "slidecreate", mID & "_create", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "slide", mID & "_slide", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "slidestart", mID & "_start", False))
	WS.RunFunction("b4j_addEvent", Array As Object("#" & mID, "slidestop", mID & "_stop", False))
	
End Sub

Sub GetID() As String
	Return mID
End Sub

' ###

Sub AddEvent(EventName As String, PreventDefault As Boolean)
	EventName = EventName.ToLowerCase
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, mID & "_" & EventName, PreventDefault))
End Sub
Sub RemoveEvent(EventName As String)
	EventName = EventName.ToLowerCase
	mWS.Eval("$(arguments[0]).off('" & EventName & "', $(arguments[1]))", Array As Object("#" & mID))
End Sub
Sub SetEventObjectName(EventObjectName As String, EventName As String, PreventDefault As Boolean)
	EventObjectName = EventObjectName.ToLowerCase
	EventName = EventName.ToLowerCase
	RemoveEvent(EventName)
	mWS.RunFunction("b4j_addEvent", Array As Object("#" & mID, EventName, EventObjectName & "_" & EventName, PreventDefault))
End Sub

' ###

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub
Sub Remove()
	mWS.Eval("$(arguments[0]).remove()", Array As Object("#" & mID))
End Sub

' ###

Sub GetMin() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).slider('option','min')", Array As Object("#" & mID))
End Sub
Sub SetMin(SliderMin As Int)
	mWS.Eval("$(arguments[0]).slider('option','min',arguments[1])", Array As Object("#" & mID, SliderMin))
End Sub

Sub GetMax() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).slider('option','max')", Array As Object("#" & mID))
End Sub
Sub SetMax(SliderMax As Int)
	mWS.Eval("$(arguments[0]).slider('option','max',arguments[1])", Array As Object("#" & mID, SliderMax))
End Sub

Sub GetOrientation() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).slider('option','orientation')", Array As Object("#" & mID))
End Sub
Sub SetOrientation(Orientation As String)
	'Possible values: "horizontal", "vertical".
	mWS.Eval("$(arguments[0]).slider('option','orientation',arguments[1])", Array As Object("#" & mID, Orientation))
End Sub

Sub GetValue() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).slider('option','value')", Array As Object("#" & mID))
End Sub
Sub SetValue(Value As Int)
	mWS.Eval("$(arguments[0]).slider('option','value',arguments[1])", Array As Object("#" & mID, Value))
End Sub

Sub GetValues() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).slider('option','values')", Array As Object("#" & mID))
End Sub
Sub SetValues(Values As List)
	mWS.Eval("$(arguments[0]).slider('option','values',arguments[1])", Array As Object("#" & mID, Values))
End Sub

Sub GetRange() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).slider('option','range')", Array As Object("#" & mID))
End Sub
Sub SetRange(Range As Boolean)
	mWS.Eval("$(arguments[0]).slider('option','range',arguments[1])", Array As Object("#" & mID, Range))
End Sub

Sub GetStep() As Future
	Return mWS.EvalWithResult("return $(arguments[0]).slider('option','step')", Array As Object("#" & mID))
End Sub
Sub SetStep(SliderStep As String)
	mWS.Eval("$(arguments[0]).slider('option','step',arguments[1])", Array As Object("#" & mID, SliderStep))
End Sub

Sub GetVisible() As Future
	Return mWS.EvalWithResult("return ($(arguments[0]).css('display')!='none')", Array As Object("#" & mID))
End Sub
Sub SetVisible(Visible As Boolean)
	If Visible = True Then
		SetCss("display", "")
	Else
		SetCss("display", "none")
	End If
End Sub

Sub SetDisabled(Disabled As Boolean)
	If Disabled = True Then
		mWS.Eval("$(arguments[0]).slider('disable');", Array As Object("#" & mID))
	Else
		mWS.Eval("$(arguments[0]).slider('enable');", Array As Object("#" & mID))
	End If
End Sub
Sub Enable()
	SetDisabled(False)
End Sub
Sub Disable()
	SetDisabled(True)
End Sub

' ######################

Sub Resize(Left As String, Top As String, Width As String, Height As String)

	Dim CSS As String

	CSS = "$(arguments[0]).css({"
	
	If Left   <> -1 Then CSS = CSS & "'left':'" & Left & "px',"
	If Top    <> -1 Then CSS = CSS & "'top':'" & Top & "px',"
	If Width  <> -1 Then CSS = CSS & "'width':'" & Width & "px',"
	If Height <> -1 Then CSS = CSS & "'height':'" & Height & "px',"
	
	If CSS.EndsWith(",") Then	
	
		CSS = CSS.SubString2(0, CSS.Length - 1)
	
		CSS = CSS & "});"
	
		mWS.Eval(CSS, Array As Object("#" & mID))
		
	End If
	
End Sub

Sub GetTop() As Future
	Return GetCss("top")
End Sub
Sub SetTop(Top As String)
	SetCss("top", Top & "px")
End Sub

Sub GetLeft As Future
	Return GetCss("left")
End Sub
Sub SetLeft(Left As String)
	SetCss("left", Left & "px")
End Sub

Sub GetWidth As Future
	Return GetCss("width")
End Sub
Sub SetWidth(Width As String)
	SetCss("width", Width & "px")
End Sub

Sub GetHeight As Future
	Return GetCss("height")
End Sub
Sub SetHeight(Height As String)
	SetCss("height", Height & "px")
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub

