﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mID As String
	Private mWS As WebSocket
	
End Sub

Public Sub Initialize(WS As WebSocket, ID As String)
	
	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String
	
	Script = "$('#'+arguments[0]).remove();" & _
					 "var selector=$('<textarea />');" & _
					 "selector.attr('id',arguments[0]);" & _
					 "selector.css('position','absolute');" & _
					 "$('body').append(selector);" & _
					 "" & _
					 "tinymce.init({" & _
					 " selector: '#'+arguments[0]," & _
					 " plugins: [ 'autolink print' ], " & _
					 "});"

	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub GetID() As String
	Return mID
End Sub

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub

Public Sub Remove()
	mWS.Eval("$(arguments[0]).remove()", Array As Object("#" & mID))
End Sub

Sub GetVisible() As Future
	Return mWS.EvalWithResult("return ($(arguments[0]).css('display')!='none')", Array As Object("#" & mID))
End Sub
Sub SetVisible(Visible As Boolean)
	If Visible = True Then
		SetCss("display", "")
	Else
		SetCss("display", "none")
	End If
End Sub

' ######################

Sub Resize(Left As String, Top As String, Width As String, Height As String)

	Dim Script As String

	Script = "var ed = tinymce.get(arguments[0]);" & _
					 "var ec = ed.editorContainer;"
				
	If Width <> -1 Then
		Script = Script & "ec.width = " & Width & ";"
	End If
	
	If Height <> -1 Then
		Script = Script & "ec.height = " & Height & ";"
	End If
	
	Script = Script & "$(ec).css({"

	If Left   <> -1 Then Script = Script & "'left':'"   & Left   & "px',"
	If Top    <> -1 Then Script = Script & "'top':'"    & Top    & "px',"
	
	If Script.EndsWith(",") Then	
		Script = Script.SubString2(0, Script.Length - 1)
		Script = Script & "});"
	End If
	
	mWS.Eval(Script, Array As Object(mID))
		
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub

