﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mID As String
	Private mWS As WebSocket

End Sub

Public Sub Initialize(WS As WebSocket, ID As String)
	
	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String
	
	Script = "$('#'+arguments[0]).remove();" & _
					 "var selector = $('<div />');" & _
					 "selector.attr('id', arguments[0]);" & _
					 "selector.css('position', 'absolute');" & _
					 "$('body').append(selector);" & _
					 "selector.w2grid({ name: arguments[0] })" 
	
	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub GetID() As String
	Return mID
End Sub

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub

Sub xRemove()
	mWS.Eval("$(arguments[0]).remove()", Array As Object("#" & mID))
End Sub

Sub SetColumns(ColumnList As List)
	mWS.Eval("w2ui[arguments[0]].columns = arguments[1];", Array As Object(mID, ColumnList))
End Sub

Sub SetRecords(RecordList As List)
	mWS.Eval("w2ui[arguments[0]].records = arguments[1];", Array As Object(mID, RecordList))
End Sub
Sub GetRecords() As Future
	Return mWS.EvalWithResult("return w2ui[arguments[0]].records;", Array As Object(mID))
	' Return mWS.EvalWithResult("return JSON.stringify(w2ui[arguments[0]].records)", Array As Object(mID))
End Sub

Sub SetToolbarVisible(Visible As Boolean)
	mWS.Eval("w2ui[arguments[0]].show.toolbar = arguments[1];", Array As Object(mID, Visible))
End Sub

Sub SetFooterVisible(Visible As Boolean)
	mWS.Eval("w2ui[arguments[0]].show.footer = arguments[1];", Array As Object(mID, Visible))
End Sub

Sub SetSearch(SearchList As List)
	mWS.Eval("w2ui[arguments[0]].searches = arguments[1];", Array As Object(mID, SearchList))
End Sub

Sub Refresh()
	mWS.Eval("w2ui[arguments[0]].refresh();", Array As Object(mID))
End Sub

' #############

'Adds a record or records to the grid.
Sub add(record)
End Sub

'Adds a column or columns to the grid.
Sub AddColumn(Column As Map)
	mWS.Eval("w2ui[arguments[0]].addColumn(arguments[1]);", Array As Object(mID, Column))
End Sub

Sub addColumn2(before, column)
End Sub
'Adds a visible range or ranges to the grid.
Sub addRange(range)
End Sub
'Adds a search or searches to the grid.
Sub addSearch(search)
End Sub
Sub addSearch2(before, search)
End Sub
'Removes all records from the grid.
Sub clear()
End Sub
Sub clear2(noRefresh)
End Sub
'Called when user clicks on a record.
Sub click(recid)
End Sub
Sub click2(recid, event)
End Sub
'Called when user clicks on the collapse record icon.
Sub collapse(recid)
End Sub
'Called when user clicks on the column.
Sub columnClick(field)
End Sub
Sub columnClick2(field, event)
End Sub
'Called when user opens grid settings (on grids toolbar) and selects an item.
Sub columnOnOff(el, event, field, value)
End Sub

'Returns selected records in tab-delimited text format.
Sub Copy()
	Return mWS.EvalWithResult("return w2ui[arguments[0]].copy()", Array As Object(mID))
End Sub

'Called when user double clicks on a record.
Sub dblClick(recid)
End Sub
Sub dblClick2(recid, event)
End Sub
'Called when user deletes record(s).
Sub delete(force)
End Sub
'Enters edit mode for the specified record and field.
Sub editField(recid, column)
End Sub
Sub editField2(recid, column, value)
End Sub
Sub editField3(recid, column, value, event)
End Sub
'Display error message dialog.
Sub error(msg)
End Sub
'Called when user clicks on the expand record icon.
Sub expand(recid)
End Sub
'Finds and returns matched records.
Sub find(match)
End Sub
Sub find2(match, returnIndex)
End Sub
'Finds the record and returns its object or index in records array.
Sub get(recid)
End Sub
Sub get2(recid, returnIndex)
End Sub
'Returns final HTML for the cell.
Sub getCellHTML(index, column_index)
End Sub
Sub getCellHTML2(index, column_index, summary)
End Sub

'Returns array of changed record objects.
Sub GetChanges() As Future
	Return mWS.EvalWithResult("return w2ui[arguments[0]].getChanges()", Array As Object(mID))
End Sub

'Finds the column and returns its object or index in columns array.
Sub getColumn(field)
End Sub
Sub getColumn2(field, returnIndex)
End Sub
'Returns HTML of grid columns.
Sub getColumnsHTML()
End Sub
'Returns HTML for grid footer.
Sub getFooterHTML()
End Sub
'Returns range data defined to the given range object.
Sub getRangeData(range)
End Sub
Sub getRangeData2(range, extra)
End Sub
'Returns final HTML for a record.
Sub getRecordHTML(index, line_number)
End Sub
Sub getRecordHTML2(index, line_number, summary)
End Sub
'Returns HTML of grid records in the scroll view.
Sub getRecordsHTML()
End Sub
'Finds the search and returns its object or index in searches array.
Sub getSearch(field)
End Sub
Sub getSearch2(field, returnIndex)
End Sub
'Returns applied search object for specified field.
Sub getSearchData(field)
End Sub
'Returns HTML of search fields.
Sub getSearchesHTML()
End Sub
'Returns current grid selection.
Sub getSelection()
End Sub
'Returns HTML of summary records.
Sub getSummaryHTML()
End Sub
'Hides a column or columns.
'Sub hideColumn(field, [field], ...)
'End Sub
'Hides a search or searches.
'Sub hideSearch(field, [field], ...)
'End Sub
'Refreshes toolbar button that allows to show/hide columns.
Sub initColumnOnOff()
End Sub
'Initializes column resize elements.
Sub initResize()
End Sub
'Initializes search fields when user opens advanced search overlay.
Sub initSearches()
End Sub
'Creates w2toolbar object based on grid.toolbar definition.
Sub initToolbar()
End Sub
'Processes keydown events.
Sub keydown(event)
End Sub
'Loads records from specified url.
Sub load(url)
End Sub
Sub load2(url, callBack)
End Sub
'Performs search on local data set.
Sub localSearch()
End Sub
Sub localSearch2(silent)
End Sub
'Performs sort on local data set.
Sub localSort()
End Sub
Sub localSort2(silent)
End Sub

'Locks the grid.
Sub Lock(Message As String, ShowSpinner As Boolean)
	mWS.Eval("w2ui[arguments[0]].lock(arguments[1], arguments[2])", Array As Object(mID, Message, ShowSpinner))
End Sub

'Merges user changes into the records array.
Sub mergeChanges()
End Sub
'Paste tab-delimmited text into the grid.
Sub parseField(obj, field)
End Sub

'Paste tab-delimmited text into the grid.
Sub Paste(Text As String)
	mWS.Eval("w2ui[arguments[0]].paste(arguments[1])", Array As Object(mID, Text))
End Sub

'Refreshes ranges defined for the grid.
Sub refreshRanges()
End Sub
'Reloads records from remote data source.
Sub reload()
End Sub
Sub reload2(callBack)
End Sub
'Removes records from the grid.
'Sub remove(recid1, recid2, ...)
'End Sub
'Removes a column or columns from the grid.
'Sub removeColumn(field, [field], ...)
'End Sub
'Removes a range or ranges from the grid.
'Sub removeRange(range_name, [range_name], ...)
'End Sub
'Removes a search or searches from the grid.
'Sub removeSearch(field, [field], ...)
'End Sub
'Prepares and submits request to the server.
Sub request(cmd)
End Sub
Sub request2(cmd, params)
End Sub
Sub request3(cmd, params, url)
End Sub
Sub request4(cmd, params, url, callBack)
End Sub
'Called to process data that was returned from the server.
Sub requestComplete(status, cmd)
End Sub
Sub requestComplete2(status, cmd, callBack)
End Sub

'Resets the grid to the initial state.
Sub Reset(NoRefresh As Boolean)
	mWS.Eval("w2ui[arguments[0]].reset(arguments[1]);", Array As Object(mID, NoRefresh))
End Sub

'Called when user saves inline editing changes.
Sub Save()
	mWS.Eval("w2ui[arguments[0]].save();", Array As Object(mID))
End Sub

'Rebuilds grids records HTML based on scroll bar position.
Sub scroll(event)
End Sub
'Called when user saves inline editing changes.
Sub scrollIntoView(ind)
End Sub
'Searches records in the grid.
Sub search(field, value)
End Sub
'Closes overlay with advanced search options (if it was open).
Sub searchClose()
End Sub
'Opens overlay with advanced search options.
Sub searchOpen()
End Sub
'Resets previous search to the default values.
Sub searchReset()
End Sub
Sub searchReset2(noRefresh)
End Sub
'Resets previous search to the default values.
Sub searchShowFields()
End Sub
'Selects records in the grid.
'Sub sselect(recid1, recid2, ...)
'End Sub
'Selects all records in the grid.
Sub selectAll()
End Sub
'Unselects all selected records in the grid.
Sub selectNone()
End Sub
'Finds the record and extends it with provided object.
Sub set(record)
End Sub
Sub set2(recid, record)
End Sub
Sub set3(recid, record, noRefresh)
End Sub
'Shows a column or columns.
'Sub showColumn(field, [field], ...)
'End Sub
'Shows a search or searches.
'Sub showSearch(field, [field], ...)
'End Sub
'Skips a number of records specified.
Sub skip(offset)
End Sub
'Sorts records in the grid.
Sub sort()
End Sub
'Displays status text.
Sub status()
End Sub
Sub status2(msg)
End Sub
'Toggles record between expand and collapse states.
Sub toggle(recid)
End Sub
'Toggles column between hidden and shown states.
'Sub toggleColumn(field, [field], ...)
'End Sub
'Toggles a search between hidden and shown states.
'Sub toggleSearch(field, [field], ...)
'End Sub
'Called when user clicks the Add New button on the toolbar.
Sub toolbarAdd()
End Sub
'Called when user clicks the Delete button on the toolbar.
Sub toolbarDelete()
End Sub
Sub toolbarDelete2(force)
End Sub

'Unlocks the grid.
Sub Unlock()
	mWS.Eval("w2ui[arguments[0]].unlock()", Array As Object(mID))
End Sub

'Unselects records in the grid.
'Sub unselect(recid1, recid2, ...)
'End Sub


' #############


Sub GetVisible() As Future
	Return mWS.EvalWithResult("return ($(arguments[0]).css('display')!='none')", Array As Object("#" & mID))
End Sub
Sub SetVisible(Visible As Boolean)
	If Visible = True Then
		SetCss("display", "")
	Else
		SetCss("display", "none")
	End If
End Sub

' ######################

Sub Resize(Left As String, Top As String, Width As String, Height As String)

	Dim CSS As String

	CSS = "$(arguments[0]).css({"
	
	If Left   <> -1 Then CSS = CSS & "'left':'" & Left & "px',"
	If Top    <> -1 Then CSS = CSS & "'top':'" & Top & "px',"
	If Width  <> -1 Then CSS = CSS & "'width':'" & Width & "px',"
	If Height <> -1 Then CSS = CSS & "'height':'" & Height & "px',"
	
	If CSS.EndsWith(",") Then	
	
		CSS = CSS.SubString2(0, CSS.Length - 1)
	
		CSS = CSS & "});"
	
		mWS.Eval(CSS, Array As Object("#" & mID))
		
	End If
	
End Sub

Sub GetTop() As Future
	Return GetCss("top")
End Sub
Sub SetTop(Top As String)
	SetCss("top", Top & "px")
End Sub

Sub GetLeft As Future
	Return GetCss("left")
End Sub
Sub SetLeft(Left As String)
	SetCss("left", Left & "px")
End Sub

Sub GetWidth As Future
	Return GetCss("width")
End Sub
Sub SetWidth(Width As String)
	SetCss("width", Width & "px")
End Sub

Sub GetHeight As Future
	Return GetCss("height")
End Sub
Sub SetHeight(Height As String)
	SetCss("height", Height & "px")
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub