﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mID As String
	Private mWS As WebSocket

	' panel: {
	' 	type:       null,    // type of the panel can be: left, right, top, bottom, preview
	' 	size:       100,     // width or height of the panel depending on panel type
	' 	minSize:    20,      // minimum size of the panel in px when it is resized
	' 	hidden:     false,   // indicates if panel is hidden
	' 	resizable:  false,   // indicates if panel is resizable
	' 	overflow:   'auto',  // overflow property of the panel, can have same values as similar CSS property
	' 	style:      '',      // additional css styles for the panel
	' 	content:    '',      // content of the pane, can be a string or an object with .render(box) method
	' 	width:      null,    // width of the panel, read only
	' 	height:     null,    // height of the panel, read only
	' 	onRefresh:  null,    // refresh event for the panel
	' 	onShow:     null,    // show event for the panel
	' 	onHide:     null     // hide event for the panel
	' }

End Sub

Public Sub Initialize(WS As WebSocket, ID As String, Panels As List)
	
	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String
	
	Script = "$('#'+arguments[0]).remove();" & _
					 "var selector = $('<div />');" & _
					 "selector.attr('id', arguments[0]);" & _
					 "selector.css('position', 'absolute');" & _
					 "$('body').append(selector);" & _
					 "selector.w2layout({name:arguments[0],panels:arguments[1]});"

	mWS.Eval(Script, Array As Object(mID, Panels))
	
End Sub

Sub GetID() As String
	Return mID
End Sub

Sub Append(ElementID As String, Panel As String)

	Dim Script As String 

	Script = "$('#layout_' + arguments[0] + '_panel_' + arguments[1]).find('.w2ui-panel-content').append($(arguments[2]))"

	mWS.Eval(Script, Array As Object(mID, Panel, "#" & ElementID.ToLowerCase))

End Sub


Sub Refresh()
	mWS.Eval("w2ui[arguments[0]].refresh();", Array As Object(mID))
End Sub

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub

Sub Remove()
	mWS.Eval("$(arguments[0]).remove()", Array As Object("#" & mID))
End Sub

' ######################

Sub Resize(Left As String, Top As String, Width As String, Height As String)

	Dim CSS As String

	CSS = "$(arguments[0]).css({"
	
	If Left   <> -1 Then CSS = CSS & "'left':'" & Left & "px',"
	If Top    <> -1 Then CSS = CSS & "'top':'" & Top & "px',"
	If Width  <> -1 Then CSS = CSS & "'width':'" & Width & "px',"
	If Height <> -1 Then CSS = CSS & "'height':'" & Height & "px',"
	
	If CSS.EndsWith(",") Then	
	
		CSS = CSS.SubString2(0, CSS.Length - 1)
	
		CSS = CSS & "});"
	
		mWS.Eval(CSS, Array As Object("#" & mID))
		
	End If
	
End Sub

Sub GetTop() As Future
	Return GetCss("top")
End Sub
Sub SetTop(Top As String)
	SetCss("top", Top & "px")
End Sub

Sub GetLeft As Future
	Return GetCss("left")
End Sub
Sub SetLeft(Left As String)
	SetCss("left", Left & "px")
End Sub

Sub GetWidth As Future
	Return GetCss("width")
End Sub
Sub SetWidth(Width As String)
	SetCss("width", Width & "px")
End Sub

Sub GetHeight As Future
	Return GetCss("height")
End Sub
Sub SetHeight(Height As String)
	SetCss("height", Height & "px")
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub

