﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mID As String
	Private mWS As WebSocket

End Sub

Public Sub Initialize(WS As WebSocket, ID As String)
	
	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String
	
	Script = "$('#'+arguments[0]).remove();" & _
					 "var selector = $('<div />');" & _
					 "selector.attr('id', arguments[0]);" & _
					 "selector.css('position', 'absolute');" & _
					 "$('body').append(selector);" & _
					 "selector.w2tabs({" & CRLF & _ 
					 " name: arguments[0], " & CRLF & _ 
					 " onClick: function(event) {" & CRLF & _ 
					 "  b4j_raiseEvent( this.name.toString().toLowerCase() + '_click', {target: event.target} ); " & CRLF & _ 
					 " }," & CRLF & _ 
					 " onClose: function(event) {" & CRLF & _ 
					 "  b4j_raiseEvent( this.name.toString().toLowerCase() + '_close', {target: event.target} ); " & CRLF & _ 
					 " }" & CRLF & _ 
					 "});" 
	
	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub GetID() As String
	Return mID
End Sub

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub

' #############

Sub AddTab(TabToAdd As Map)
	mWS.Eval("w2ui[arguments[0]].add(arguments[1]);", Array As Object(mID, TabToAdd))
End Sub

Sub RemoveTab(TabIdToRemove As String)
	mWS.Eval("w2ui[arguments[0]].remove(arguments[1]);", Array As Object(mID, TabIdToRemove))
End Sub

Sub SelectTab(TabIdToSelect As String)
	mWS.Eval("w2ui[arguments[0]].select(arguments[1]);", Array As Object(mID, TabIdToSelect))
End Sub

Sub EnableTab(TabIdToEnable As String)
	mWS.Eval("w2ui[arguments[0]].enable(arguments[1]);", Array As Object(mID, TabIdToEnable))
End Sub

Sub DisableTab(TabIdToDisable As String)
	mWS.Eval("w2ui[arguments[0]].disable(arguments[1]);", Array As Object(mID, TabIdToDisable))
End Sub

Sub HideTab(TabIdToHide As String)
	mWS.Eval("w2ui[arguments[0]].hide(arguments[1]);", Array As Object(mID, TabIdToHide))
End Sub

Sub ShowTab(TabIdToShow As String)
	mWS.Eval("w2ui[arguments[0]].show(arguments[1]);", Array As Object(mID, TabIdToShow))
End Sub

' #############

Sub GetVisible() As Future
	Return mWS.EvalWithResult("return ($(arguments[0]).css('display')!='none')", Array As Object("#" & mID))
End Sub
Sub SetVisible(Visible As Boolean)
	If Visible = True Then
		SetCss("display", "")
	Else
		SetCss("display", "none")
	End If
End Sub

' ######################

Sub Resize(Left As String, Top As String, Width As String, Height As String)

	Dim CSS As String

	CSS = "$(arguments[0]).css({"
	
	If Left   <> -1 Then CSS = CSS & "'left':'" & Left & "px',"
	If Top    <> -1 Then CSS = CSS & "'top':'" & Top & "px',"
	If Width  <> -1 Then CSS = CSS & "'width':'" & Width & "px',"
	If Height <> -1 Then CSS = CSS & "'height':'" & Height & "px',"
	
	If CSS.EndsWith(",") Then	
	
		CSS = CSS.SubString2(0, CSS.Length - 1)
	
		CSS = CSS & "});"
	
		mWS.Eval(CSS, Array As Object("#" & mID))
		
	End If
	
End Sub

Sub GetTop() As Future
	Return GetCss("top")
End Sub
Sub SetTop(Top As String)
	SetCss("top", Top & "px")
End Sub

Sub GetLeft As Future
	Return GetCss("left")
End Sub
Sub SetLeft(Left As String)
	SetCss("left", Left & "px")
End Sub

Sub GetWidth As Future
	Return GetCss("width")
End Sub
Sub SetWidth(Width As String)
	SetCss("width", Width & "px")
End Sub

Sub GetHeight As Future
	Return GetCss("height")
End Sub
Sub SetHeight(Height As String)
	SetCss("height", Height & "px")
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub