﻿Type=Class
Version=3.61
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	
	Private mID As String
	Private mWS As WebSocket

End Sub

Public Sub Initialize(WS As WebSocket, ID As String)
	
	mWS = WS
	mID = ID.ToLowerCase

	Dim Script As String
	
	Script = "$('#'+arguments[0]).remove();" & _
					 "var selector = $('<div />');" & _
					 "selector.attr('id', arguments[0]);" & _
					 "$('body').append(selector);" & _
					 "selector.w2toolbar({"  & _
					 " name: arguments[0], "  & _
					 " onClick: function(event) {"  & _
					 "  if (event.subItem != null) {" & _
					 "    b4j_raiseEvent( event.subItem.id.toString().toLowerCase() + '_click', event.subItem ); " & _
					 "  } else { " & _
					 "    b4j_raiseEvent( event.target.toString().toLowerCase() + '_' + event.type, event.item ); " & _
					 "  } " & _
					 " }"  & _
					 "});" 
	
	mWS.Eval(Script, Array As Object(mID))
	
End Sub

Sub AppendTo(ElementID As String)
	mWS.Eval("$(arguments[0]).appendTo($(arguments[1]))", Array As Object("#" & mID, "#" & ElementID.ToLowerCase))
End Sub

Sub Remove()
	mWS.Eval("w2ui[arguments[0]].destroy();", Array As Object(mID))
	mWS.Eval("$(arguments[0]).remove()", Array As Object("#" & mID))
End Sub

Sub AddItems(ItemList As List)
	mWS.Eval("w2ui[arguments[0]].add(arguments[1]);", Array As Object(mID, ItemList))
End Sub

Sub RemoveItem(ItemID As String)
	mWS.Eval("w2ui[arguments[0]].remove(arguments[1]);", Array As Object(mID, ItemID))
End Sub

Sub EnableItem(ItemID As String)
	mWS.Eval("w2ui[arguments[0]].enable(arguments[1]);", Array As Object(mID, ItemID))
End Sub

Sub DisableItem(ItemID As String)
	mWS.Eval("w2ui[arguments[0]].disable(arguments[1]);", Array As Object(mID, ItemID))
End Sub

Sub CheckItem(ItemID As String)
	mWS.Eval("w2ui[arguments[0]].check(arguments[1]);", Array As Object(mID, ItemID))
End Sub

Sub UncheckItem(ItemID As String)
	mWS.Eval("w2ui[arguments[0]].uncheck(arguments[1]);", Array As Object(mID, ItemID))
End Sub

Sub Refresh()
	mWS.Eval("w2ui[arguments[0]].refresh();", Array As Object(mID))
End Sub

Sub GetVisible() As Future
	Return mWS.EvalWithResult("return ($(arguments[0]).css('display')!='none')", Array As Object("#" & mID))
End Sub
Sub SetVisible(Visible As Boolean)
	If Visible = True Then
		SetCss("display", "")
	Else
		SetCss("display", "none")
	End If
End Sub

' ######################

Sub GetCss(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetCss(Property)
End Sub
Sub SetCss(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetCss(Property, Value)
End Sub

Sub GetAttr(Property As String) As Future
	Return mWS.EvalWithResult("return $(arguments[0]).attr(arguments[1])", Array As Object("#" & mID, Property))
End Sub
Sub SetAttr(Property As String, Value As String)
	mWS.Eval("$(arguments[0]).attr(arguments[1], arguments[2])", Array As Object("#" & mID, Property, Value))
End Sub

Sub GetProp(Property As String) As Future
	Return mWS.GetElementBySelector("#" & mID).GetProp(Property)
End Sub
Sub SetProp(Property As String, Value As String)
	mWS.GetElementBySelector("#" & mID).SetProp(Property, Value)
End Sub